;***************************************************************************
; Some subroutines for timing-management

;------------------------------------------------
;subroutine for event timing
;checks if time (sys_time) has passed contents of a selected timer register
;input: W= timing register address (linear addressing!)
;returns STATUS,C:
;C=1 if sys_time >= timing register, W milliseconds since expiration 
;C=0 if time has not yet expired
;leaves FSR0 = selected timer register
check_time
	movwf	FSR0L
	movlw	0x20
	movwf	FSR0H
;like check_time, but (FSR0) = time_reg, rather than W
check_time_fsr0
	call	sys_tm_adj		;update sys_time 

	moviw	0[FSR0]			;sys_time - tim_reg: >= 0 if t.expired
	subwf	sys_time,W		
	movwf	temp			;case time is over: save passed ms	
	moviw	1[FSR0]			
	subwfb	sys_time+1,W
	sublw	0x7F			;C = inverse MSB(W)
	movf	temp,W
	return

;------------------------------------------------
;subroutine for event timing
;sets expiration time (FSR0) to WREG milliseconds from current sys_time

set_time_fsr0
	movwi	0[FSR0]

	call	sys_tm_adj
	
	movf	sys_time,W
	addwf	INDF0,F
	movlw	0
	addwfc	sys_time+1,W
	movwi	1[FSR0]
	return

;------------------------------------------------
;subroutine for event timing
;adds W milliseconds to expiration time (FSR0) 

add_time_fsr0
	addwf	INDF0,F
	btfss	STATUS,C
	return
	moviw	1[FSR0]
	addlw	1
	movwi	1[FSR0]
	return