;-------------------------------------------------------------
;Macro: converts address from linear address to
;traditional, banking based register address 
;result => BNK_ADDR  
LIN2TDM MACRO la
 if la >= MAXBUFSIZE
	error cannot convert linear address la to traditional address   	
 endif
	local bnk = 0
BNK_ADDR set la
 while BNK_ADDR > 0x4F
BNK_ADDR -= 0x50
bnk += 1
 endw
BNK_ADDR += 0x20 + (bnk<<7)
	ENDM

;-------------------------------------------------------------
;Macro: converts address from traditional, banking based
;data memory address to linear address (for FSR = 0x20XX)
;result => LIN_ADDR  
TDM2LIN MACRO f_reg
BNK_ADDR set f_reg
LIN_ADDR set f_reg-0x20
 if BNK_ADDR < 0x20
	error cannot convert f_reg to linear address!
 endif
 while BNK_ADDR > 0x6F
LIN_ADDR -= 0x30
BNK_ADDR -= 0x80
	
   if BNK_ADDR < 0x20
	error cannot convert f_reg to linear address!
   endif
 endw
	ENDM
;-------------------------------------------------------------
;Macro: load WREG with linear equivalent of address (f_reg)
MOVLW_LIN MACRO f_reg
	TDM2LIN f_reg
	movlw	LIN_ADDR
	ENDM

;-------------------------------------------------------------
;Macro: inline version of "call chkbuffer"
;conserves 3 instruction cycles compared to call 

CHKBUFFER MACRO
	incf	ptr_wr,W		;check if there is enough free space in buffer (min 3 bytes):
	subwf	ptr_rd,W		;W = # of free bytes in buffer
	btfss	STATUS,C
	addwf	bufsize,W		;ptr_wr < ptr_rd: rollover!
	addlw	-3			;need space for 3 bytes  
	btfss	STATUS,C		;C=1 if >= 3 bytes free
	call	chkbuf_wait

	ENDM
;-------------------------------------------------------------


